; [url=http://www.masm32.com/board/index.php?topic=1589.msg12747#msg12747]original source[/url] (stillslow.zip)
.nolist
include \masm32\include\masm32rt.inc

.686
; .k3d
.xmm
include \masm32\macros\timers.asm

Main		proto
SzCpy10	proto :DWORD,:DWORD
MbCopy	proto :DWORD,:DWORD
szCopyMMX	proto :DWORD,:DWORD
SzCpy11	proto :DWORD,:DWORD
szCopyMMX1	proto :DWORD,:DWORD

.data
align 16

spoil1	db 1, 2, 3		; badly aligned source - REMOVE TO SEE A CRASH (Ctrl C terminates)

String1     DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play "
                DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play "
                DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play "
                DB  "Sample String 01234 56789 ABCDEF AaBbCcDdEeFfGgHhIiJjKkLlMMNnOoP",\
                "pQqRrSsTtUuVvWwXxYyZz Now I Know My ABC's, Won't You Come Play ", 0
                db "RUBBISH for testing the boundaries"

align 16

spoil2	db 1, 2, 3, 4, 5		; badly aligned destination (removing does NOT cause a crash)

String2     DB  4*128 dup(0)
                db "rubbish for testing the boundaries"
                db 100 dup("x")	; see what happens if you comment this line

LOOP_COUNT  EQU 1000000        ; 1M iterations per timing result
SleepTime = 100

SzSzCpy10	DB  "SzCpy10        - > Lingo ->        MMX: ",0
sszCopyMMX	DB  "szCopyMMX   -> Mark Larson   ->    MMX: ",0
SzSzCpy11	DB   "SzCpy11  -- > Lingo ->  MMX   ->  Fast: ",0
sszCopyMMX1	DB  "szCopyMMX1-> Mark Larson -> MMX-> Fast: ",0

.code

Start:
  Invoke Main
  Invoke ExitProcess,0

Main Proc
    print chr$(" Timing routines by MichaelW from MASM32 forums, http://www.masmforum.com/",13,10)
    ; mov   eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    
    top = 1		; change order
    seeresult = 0
   
    if seeresult eq 2	; test slows down enormously if you activate this
	invoke MbCopy, addr String2, addr String1	; test if it works properly
	print chr$(13, 10, "Dest=  ", 9)
	print offset String2
    endif
    
    print chr$(13,10,13,10," 512-byte string copy timing results:",13,10,13,10)
    

; ---------- Lingo 1-------------------------------------  
    if top eq 1
    print addr SzSzCpy10
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy10, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    if top eq 1
    print chr$("MbCopy     -> jj   -> ", 9, 9,"   xmm: ")
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke MbCopy, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    print addr sszCopyMMX
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke szCopyMMX , addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print addr SzSzCpy11
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy11, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------  
    print addr sszCopyMMX1
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke szCopyMMX1 , addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print chr$(9,9,9,9,"szCopy", 9)
    counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
    invoke szCopy, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   
    print chr$(9,9,9,9,"lstrcpy", 9)
    counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
    invoke lstrcpy, addr String1, addr String2
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
; -----------------------------------------------   

; ---------- Lingo 1-------------------------------------  
    if top eq 0
    print addr SzSzCpy10
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke SzCpy10, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    invoke Sleep, SleepTime
    endif
; -----------------------------------------------  
    if top eq 0
    print chr$("MbCopy     -> jj   -> ", 9, 9,"   xmm: ")
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
    invoke MbCopy, addr String2, addr String1
    counter_end
    print str$(eax)
    print chr$(" clocks",13,10)
    if seeresult	; test slows down enormously if you activate this
	print chr$(13, 10, "Result= ", 9)
	print offset String2
    endif
    invoke Sleep, SleepTime
    endif

    ; mov   eax, input(13,10," Press ENTER to exit...")
    ret
Main EndP



OPTION PROLOGUE:NONE   ; It  is SzCpy10  MMX by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@2:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			bl,		bl
	lea			eax,		[eax+8]
	je				@B
@@:									
	movzx	    ebx, byte ptr [ecx+eax-8]		
	add			eax, 1
	test			bl, bl
	mov			[edx+eax-9], bl
	jnz			@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy10   proc    SzDest:DWORD, SzSource:DWORD
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@2
 SzCpy10 endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
MbCopy proc SzDest:DWORD, SzSource:DWORD
 ; ------- credits to [url=http://www.masm32.com/board/index.php?topic=1589.msg12747#msg12747]Lingo[/url] --------
	mov ecx, [esp+2*4]		; ecx = source
	xor eax, eax
	mov edx, [esp+1*4]		; edx= destination
	pxor xmm7,xmm7
	movq xmm1, qword ptr [ecx]
	; mov [esp+2*4], ebx		; save ebx register: not faster
	push ebx
 je @@2a

; align 16 makes it lose 10 cycles
@@:
	movq xmm1, qword ptr [ecx+eax]
	movq qword ptr [edx+eax-8], xmm0
@@2a:
	movq xmm0, qword ptr [ecx+eax]	; throws exception here				
	pcmpeqb xmm1, xmm7
	packsswb xmm1, xmm1
	movd ebx, xmm1
	test bl, bl
	lea eax, [eax+8]
	je @B
@@:
	movzx ebx, byte ptr [ecx+eax-8]		
	add eax, 1
	test bl, bl
	mov [edx+eax-9], bl
	jnz @B
	; mov ebx, [esp+2*4]	; not faster than pop
	pop ebx
	ret 2*4
MbCopy endp
 
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE   ; It  is SzCpy11  MMX  Fast by Lingo
OPTION EPILOGUE:NONE
comment * MMX by Lingo*
align 16
@@:
	movq		MM1,	[ecx+eax]
    movq		[edx+eax-8], MM0
@@21:
    movq		MM0,	[ecx+eax]					
	pcmpeqb	MM1,	MM7
	packsswb	MM1,	MM1
	movd		ebx,		MM1
	test			ebx,		ebx
	lea			eax,		[eax+8]
	je				@B
	mov			ebx, [esp+2*4]						
	ret			2*4
align 16
SzCpy11   proc    SzDest:DWORD, SzSource:DWORD
;int 3
;				finit			trashes the FPU
;				mov eax, 12345678
;				push eax
;				fild dword ptr [esp]
				mov		ecx, [esp+2*4]		; ecx = source
				xor		eax, eax
				mov		edx, [esp+1*4]		;  edx= destination
 				pxor		MM7,MM7
				movq	MM1, [ecx]
				mov		[esp+2*4], ebx		;  save ebx register
				je			@@21
 SzCpy11 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX by Mark Larson *

align 16
szCopyMMX proc near src_str:DWORD, dst_str:DWORD
   mov eax,[esp+4]
   mov esi,[esp+8]


align 16
qword_copy:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest
   movq [esi],MM0
   add esi,8
   jmp qword_copy

finish_rest:
;ret 8

;if 0
bsf ecx,ecx
cmp ecx,7
je do_7
cmp ecx,6
je do_6
cmp ecx,5
je do_5
cmp ecx,4
je do_4
cmp ecx,3
je do_3
cmp ecx,2
je do_2

do_7:
mov ecx,[eax-8]
mov edx,[eax+4-8] ;really copy 8 bytes to include the 0
mov [esi],ecx
mov [esi+4],edx
ret 8 ; ret

do_6:
mov ecx,[eax-8]
movzx edx,word ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dx
mov byte ptr [esi+6],0
ret 8 ; ret

do_5:
mov ecx,[eax-8]
movzx edx,byte ptr[eax+4-8]
mov [esi],ecx
mov [esi+4],dl
mov byte ptr [esi+5],0
ret 8 ; ret


do_4:
mov ecx,[eax-8]
mov [esi],ecx
mov byte ptr [esi+4],0
ret 8 ; ret


do_3:
movzx ecx,word ptr[eax-8]
movzx edx,byte ptr[eax+2-8]
mov [esi],cx
mov [esi+2],dl
mov byte ptr [esi+3],0
ret 8 ; ret

do_2:
movzx ecx,word ptr[eax-8]
mov byte ptr [esi+2],0
ret 8 ; ret

;cmp ecx,1
;je do_1
movzx ecx,byte ptr [eax-8]
mov [esi],cl
ret 8 ; ret

szCopyMMX endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       


OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
comment * MMX  Fast by Mark Larson *

align 16
szCopyMMX1 proc near src_str:DWORD, dst_str:DWORD
   mov eax,[esp+4]
   mov esi,[esp+8]

align 16
qword_copy1:
   pxor MM1,MM1
   movq MM0,[eax] 
   pcmpeqb MM1,MM0
   add eax,8 
   pmovmskb ecx,MM1
   or ecx,ecx 
   jnz finish_rest1
   movq [esi],MM0
   add esi,8
   jmp qword_copy1
finish_rest1:
ret 8
szCopyMMX1 endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef       

End Start
OPT_Assembler mlv9
OPT_Tmp2Asm	1
OPT_Res	0
